



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python @property 详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python @property 详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 11:12:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>本文讲解了 Python 的 property 特性，即一种符合 Python 哲学地设置 getter 和 setter 的方式。</p></blockquote>
<p>Python 有一个概念叫做 property，它能让你在 Python 的面向对象编程中轻松不少。在了解它之前，我们先看一下为什么 property 会被提出。</p>
<h3>一个简单的例子</h3>
<p>比如说你要创建一个温度的类<code>Celsius</code>，它能存储摄氏度，也能转换为华氏度。即：</p>
<pre class="prettyprint linenums"><code>class Celsius:<br />
    def __init__(self, temperature = 0):<br />
        self.temperature = temperature

    def to_fahrenheit(self):<br />
        return (self.temperature * 1.8) + 32<br />
</code></pre>
<p>我们可以使用这个类：</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; # 创建对象 man<br />
&gt;&gt;&gt; man = Celsius()

&gt;&gt;&gt; # 设置温度<br />
&gt;&gt;&gt; man.temperature = 37

&gt;&gt;&gt; # 获取温度<br />
&gt;&gt;&gt; man.temperature<br />
37

&gt;&gt;&gt; # 获取华氏度<br />
&gt;&gt;&gt; man.to_fahrenheit()<br />
98.60000000000001<br />
</code></pre>
<blockquote><p>最后额外的小数部分是浮点误差，属于正常现象，你可以在 Python 里试一下 <code>1.1 + 2.2</code>。</p></blockquote>
<p>在 Python 里，当我们对一个对象的属性进行赋值或估值时（如上面的<code>temperature</code>），Python 实际上是在这个对象的 <code>__dict__</code>字典里搜索这个属性来操作。</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; man.__dict__<br />
{'temperature': 37}<br />
</code></pre>
<p>因此，<code>man.temperature</code>实际上被转换成了<code>man.__dict__['temperature']</code>。</p>
<p>假设我们这个类被程序员广泛的应用了，他们在数以千计的客户端代码里使用了我们的类，你很高兴。</p>
<p>突然有一天，有个人跑过来说，<strong>温度不可能低于零下273度</strong>，这个类应该加上对温度的限制。这个建议当然应该被采纳。作为一名经验丰富的程序员，你立刻想到应该使用 setter 和 getter 来限制温度，于是你将代码改成下面这样：</p>
<pre class="prettyprint linenums"><code>class Celsius:<br />
    def __init__(self, temperature = 0):<br />
        self.set_temperature(temperature)

    def to_fahrenheit(self):<br />
        return (self.get_temperature() * 1.8) + 32

    # 更新部分<br />
    def get_temperature(self):<br />
        return self._temperature

    def set_temperature(self, value):<br />
        if value &lt; -273:<br />
            raise ValueError(&quot;Temperature below -273 is not possible&quot;)<br />
        self._temperature = value<br />
</code></pre>
<p>很自然地，你使用了“私有变量”<code>_temperature</code>来存储温度，使用<code>get_temperature()</code>和<code>set_temperature()</code>提供了访问<code>_temperature</code>的接口，在这个过程中对温度值进行条件判断，防止它超过限制。这都很好。</p>
<p>问题是，这样一来，使用你的类的程序员们需要把他们的代码中无数个<code>obj.temperature = val</code>改为<code>obj.set_temperature(val)</code>，把<code>obj.temperature</code>改为<code>obj.get_temperature()</code>。这种重构实在令人头痛。</p>
<p>所以，这种方法不是“向下兼容”的，我们要另辟蹊径。</p>
<h3>@property 的威力！</h3>
<p>想要使用 Python 哲学来解决这个问题，就使用 property。直接看代码：</p>
<pre class="prettyprint linenums"><code>class Celsius:<br />
    def __init__(self, temperature = 0):<br />
        self.temperature = temperature

    def to_fahrenheit(self):<br />
        return (self.temperature * 1.8) + 32

    def get_temperature(self):<br />
        print(&quot;Getting value&quot;)<br />
        return self._temperature

    def set_temperature(self, value):<br />
        if value &lt; -273:<br />
            raise ValueError(&quot;Temperature below -273 is not possible&quot;)<br />
        print(&quot;Setting value&quot;)<br />
        self._temperature = value

    # 重点在这里<br />
    temperature = property(get_temperature,set_temperature)<br />
</code></pre>
<p>我们在<code>class Celsius</code>的最后一行使用了一个 Python 内置函数（类） <code>property()</code>。它接受两个函数作为参数，一个 getter，一个 setter，并且返回一个 property 对象（这里是<code>temperature</code>）。</p>
<p>这样以后，<strong>任何访问<code>temperature</code>的代码都会自动转而运行<code>get_temperature()</code>，任何对<code>temperature</code>赋值的代码都会自动转而运行<code>set_temperature()</code>。</strong>我们在代码里加了<code>print()</code>便于测试它们的运行状态。</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; c = Celsius()  # 此时会运行 setter，因为 __init__ 里对 temperature 进行了赋值<br />
Setting value

&gt;&gt;&gt; c.temperature  # 此时会运行 getter，因为对 temperature 进行了访问<br />
Getting value<br />
0<br />
</code></pre>
<p>需要注意的是，实际的温度存储在<code>_temperature</code>里，<code>temperature</code>只是提供一个访问的接口。</p>
<h3>深入了解 Property</h3>
<p>正如之前提到的，<code>property()</code>是 Python 的一个内置函数，同时它也是一个类。函数签名为：</p>
<pre class="prettyprint linenums"><code>property(fget=None, fset=None, fdel=None, doc=None)<br />
</code></pre>
<p>其中，<code>fget</code>是一个 getter 函数，<code>fset</code>是一个 setter 函数，<code>fdel</code>是删除该属性的函数，<code>doc</code>是一个字符串，用作注释。函数返回一个 property 对象。</p>
<p>一个 property 对象有 <code>getter()</code>、<code>setter()</code>和<code>deleter()</code>三个方法用来指定相应绑定的函数。之前的</p>
<pre class="prettyprint linenums"><code>temperature = property(get_temperature,set_temperature)<br />
</code></pre>
<p>实际上等价于</p>
<pre class="prettyprint linenums"><code># 创建一个空的 property 对象<br />
temperature = property()<br />
# 绑定 getter<br />
temperature = temperature.getter(get_temperature)<br />
# 绑定 setter<br />
temperature = temperature.setter(set_temperature)<br />
</code></pre>
<p>这两个代码块等价。</p>
<p>熟悉 Python 装饰器的程序员肯定已经想到，上面的 property 可以用装饰器来实现。</p>
<p>通过装饰器<code>@property</code>，我们可以不定义没有必要的 <code>get_temperature()</code>和<code>set_temperature()</code>，这样还避免了污染命名空间。使用方式如下：</p>
<pre class="prettyprint linenums"><code>class Celsius:<br />
    def __init__(self, temperature = 0):<br />
        self._temperature = temperature

    def to_fahrenheit(self):<br />
        return (self.temperature * 1.8) + 32

    # Getter 装饰器<br />
    @property<br />
    def temperature(self):<br />
        print(&quot;Getting value&quot;)<br />
        return self._temperature

    # Setter 装饰器<br />
    @temperature.setter<br />
    def temperature(self, value):<br />
        if value &lt; -273:<br />
            raise ValueError(&quot;Temperature below -273 is not possible&quot;)<br />
        print(&quot;Setting value&quot;)<br />
        self._temperature = value<br />
</code></pre>
<p>你可以使用装饰器，也可以使用之前的方法，完全看个人喜好。但使用装饰器应该是更加 Pythonic 的方法吧。</p>
<h3>参考</h3>
<p><a href="https://www.programiz.com/python-programming/property" rel="external nofollow noreferrer">Python @property</a></p>
<p>（本文完）</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4z25e9.html">Go语言 字符串处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq44yo0q.html">gRPC&plus;etcd的优势分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1odd58.html">jsp遍历、循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evo6x9.html">AngularJS和DataModel</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okn46x9.html">mysql建库DATETIME、DATE 和 TIMESTAMP区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5jdyq.html">Hadoop3&period;0新特性介绍，比Spark快10倍的Hadoop3&period;0新特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnd65j8.html">MongoDB的基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydvm6mq.html">Windows Server 2008R2配置MySQL Cluster并将管理节点和数据节点配置成windows服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4vpdq.html">说说shell脚本中的export 和 source，bash</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zlxx09.html">C&plus;&plus;：静态成员</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xyj6v8.html">jquery formatCurrency货币格式化处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvg4oyq.html">如何避免JSP乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg4y2d8.html">linux中tar  打包指定路径文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpx7kvq.html">select超链接跳转A</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pky0v8.html">Sping Boot入门到实战之入门篇（四）：Spring Boot自动化配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252r1oq.html">php -- new self&lpar;&rpar; 和 new static</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1vkm9.html">Spring Data Redis示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjpvozq.html">C&num; MemCached分布式缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvee36j9.html">在天河二号上对比Julia，Python和R语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp22k49.html">C&sol;C&plus;&plus;作用域运算符&colon;&colon;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojeedlq.html">C语言博客作业06&mdash;&mdash;结构体&amp;amp&semi;文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k31759.html">轻量Pythonweb - flask&plus;jinja2</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z0lo39.html">k8s网络之设计与实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gew2ol8.html">Aras 发布Web Services</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgvzg48.html">windows下搭建Kafka，并通过命令窗口收发消息</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zkmwj9.html">VS Code保存使用项目Eslint规则格式化代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk7n1d8.html">使用Lottie将AE项目转换为 Web 原生动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv14171q.html">openGL learning</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgvgpr8.html">A Discriminative Feature Learning Approach for Deep Face Recognition</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6lex9.html">osgearth介绍</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
